
  1                       Version 4.0 -- 5/1/89               bcp_colptr
  ______________________________________________________________________

  NAME:  bcp_colptr

  FUNCTION:
       Set the program variable data address for the current copy IN.

  SYNTAX:
       RETCODE bcp_colptr(dbproc, colptr, table_column)

       DBPROCESS *dbproc;
       BYTE      *colptr;
       int       table_column;








  bcp_colptr              Version 4.0 -- 5/1/89                        2
  ______________________________________________________________________

  COMMENTS:

       o The bcp_colptr() function allows  you  to  change  the  program
         variable  data  address for a particular column while running a
         copy IN via calls to bcp_bind().
       o Initially, the program variable data address is determined when
         bcp_bind()  is  called.  If  the  program variable data address
         changes  between  calls  to   bcp_sendrow(),   you   may   call
         bcp_colptr()  to  reset the address of the data.  The next call
         to bcp_sendrow() will use the data at the address you just set.

       o There must be a separate bcp_colptr() call for every column  in
         the table whose data address you want to modify.
       o For information on the bcp utility program, see its manual page
         in the Commands Reference.




  3                       Version 4.0 -- 5/1/89               bcp_colptr
  ______________________________________________________________________

  PARAMETERS:
       dbproc -  A pointer to the DBPROCESS structure that provides  the
           connection for a particular front-end/SQL Server process.  It
           contains all the information that DB-Library uses  to  manage
           communications and data between the front end and SQL Server.
       colptr -  The address of the program variable.
       table_column -  The column in the SQL Server table to  which  the
           data will be copied. Column numbers start at 1.

  RETURNS:
       SUCCEED or FAIL.

  SEE ALSO:
       bcp_bind, bcp_collen, bcp_sendrow




