
  1                       Version 4.0 -- 5/1/89                 BCP_SETL
  ______________________________________________________________________

  NAME:  BCP_SETL

  FUNCTION:
       Set the LOGINREC for bulk copy operations.

  SYNTAX:
       RETCODE BCP_SETL(loginrec, enable)

       LOGINREC  *loginrec;
       DBBOOL    enable;

  COMMENTS:







  BCP_SETL                Version 4.0 -- 5/1/89                        2
  ______________________________________________________________________

       o This macro sets a field in the LOGINREC  structure  that  tells
         SQL Server  that  the DBPROCESS connection may be used for bulk
         copy operations.  For it to have any effect, it must be  called
         before dbopen(), the routine that actually allocates the DBPRO-
         CESS structure.
       o Applications that allow users to make ad hoc queries  may  want
         to  avoid  calling  this  macro  (or to call it with the enable
         parameter FALSE), in order to keep users from initiating a bulk
         copy  sequence  via SQL commands. Once a bulk copy sequence has
         begun, it cannot be stopped via an ordinary SQL command.

       o For information on the bcp utility program, see its manual page
         in the Commands Reference.

  PARAMETERS:
       loginrec -  This is a pointer to a LOGINREC structure, which will
           be  passed  as  an  argument  to dbopen(). You can get one by


  3                       Version 4.0 -- 5/1/89                 BCP_SETL
  ______________________________________________________________________
           calling dblogin().
       enable -  This is a Boolean value (TRUE or FALSE),  which  speci-
           fies  whether  or  not to enable bulk copy operations for the
           resulting DBPROCESS. By default, DBPROCESSes are not  enabled
           for bulk copy operations.

  RETURNS:
       SUCCEED or FAIL.

  SEE ALSO:
       bcp_init,  dblogin,  dbopen,  DBSETLAPP,  DBSETLHOST,  DBSETLPWD,
       DBSETLUSER








  BCP_SETL                Version 4.0 -- 5/1/89                        4
  ______________________________________________________________________



















