
  1                       Version 4.0 -- 5/1/89                  dbaltop
  ______________________________________________________________________

  NAME:  dbaltop

  FUNCTION:
       Return the type of aggregate operator for  a  particular  compute
       column.

  SYNTAX:
       int dbaltop(dbproc, computeid, column)

       DBPROCESS *dbproc;
       int       computeid;
       int       column;







  dbaltop                 Version 4.0 -- 5/1/89                        2
  ______________________________________________________________________

  COMMENTS:

       o This routine returns the type of aggregate operator for a  par-
         ticular column in a compute.  For example, given the SQL state-
         ment:

              select dept, name from employee
                order by dept, name
                compute count(name) by dept

         the call dbaltop(dbproc, 1, 1) will return the token value  for
         count  since  the first aggregate operator in the first compute
         is a count.
       o You can convert the token value to a readable token string with
         dbprtype().   See  the dbprtype() manual page for a list of all
         token values and their equivalent token strings.



  3                       Version 4.0 -- 5/1/89                  dbaltop
  ______________________________________________________________________

  PARAMETERS:
       dbproc -  A pointer to the DBPROCESS structure that provides  the
           connection for a particular front-end/SQL Server process.  It
           contains all the information that DB-Library uses  to  manage
           communications and data between the front end and SQL Server.
       computeid -  The id that identifies the particular compute row of
           interest.   A  SQL SELECT statement may have multiple COMPUTE
           clauses, each of which returns a separate compute  row.   The
           computeid  corresponding  to  the  first  COMPUTE clause in a
           SELECT is 1.  The computeid is  returned  by  dbnextrow()  or
           dbgetrow().
       column -  The number of the column of interest.  The first column
           is number 1.

  RETURNS:
       A token value for the type  of  the  compute  column's  aggregate



  dbaltop                 Version 4.0 -- 5/1/89                        4
  ______________________________________________________________________
       operator.

  SEE ALSO:
       dbadata, dbadlen, dbaltlen, dbnextrow, dbnumalts, dbprtype















