
  1                       Version 4.0 -- 5/1/89                 dbcancel
  ______________________________________________________________________

  NAME:  dbcancel

  FUNCTION:
       Cancel the current command batch.

  SYNTAX:
       RETCODE dbcancel(dbproc)

       DBPROCESS *dbproc;

  COMMENTS:

       o This routine cancels execution of the current command batch  on






  dbcancel                Version 4.0 -- 5/1/89                        2
  ______________________________________________________________________
         SQL Server and flushes any pending  results.   The  application
         can  call it after calling dbsqlexec(), dbsqlsend(), dbsqlok(),
         dbresults(), or dbnextrow().   dbcancel()  sends  an  attention
         packet  to  SQL Server, which causes SQL Server to cease execu-
         tion of the command batch.  Any pending results  are  read  and
         discarded.

       o dbcancel() cancels all the  commands  in  the  current  command
         batch.  To  cancel  only  the results from the current command,
         call dbcanquery() instead.
       o If you have set your own interrupt  handler  using  dbsetinter-
         rupt(),  you  can't  call dbcancel() in your interrupt handler.
         This would cause output from SQL Server to DB-Library to become
         out  of  sync.  If you want to cancel the current command batch
         from your interrupt handler, the interrupt handler should set a
         flag  that you can check before the next call to dbresults() or
         dbnextrow().



  3                       Version 4.0 -- 5/1/89                 dbcancel
  ______________________________________________________________________




  PARAMETERS:
       dbproc -  A pointer to the DBPROCESS structure that provides  the
           connection for a particular front-end/SQL Server process.  It
           contains all the information that DB-Library uses  to  manage
           communications and data between the front end and SQL Server.

  RETURNS:
       SUCCEED or FAIL.  The most common reasons for failure are a  dead
       DBPROCESS or a network error.

  SEE ALSO:
       dbcancel_a,  dbcanquery,  dbnextrow,  dbresults,  dbsetinterrupt,
       dbsqlexec, dbsqlok, dbsqlsend


