
  1                       Version 4.0 -- 5/1/89               dbcanquery
  ______________________________________________________________________

  NAME:  dbcanquery

  FUNCTION:
       Cancel any rows pending from the most recently executed query.

  SYNTAX:
       RETCODE dbcanquery(dbproc)

       DBPROCESS *dbproc;

  COMMENTS:

       o This routine is an efficient way to throw away any unread  rows






  dbcanquery              Version 4.0 -- 5/1/89                        2
  ______________________________________________________________________
         that result from the most recently executed SQL query.  Calling
         dbcanquery()  is  equivalent  to  calling  dbnextrow() until it
         returns NO_MORE_ROWS, but dbcanquery()  is  faster  because  it
         allocates no memory and executes no bindings to user data.

       o If you have set your own interrupt  handler  using  dbsetinter-
         rupt(),  you can't call dbcanquery() in your interrupt handler.
         This would cause output from SQL Server to DB-Library to become
         out  of  sync.   If you want to ignore any unread rows from the
         current query, the interrupt handler should set a flag that you
         can check before the next call to dbnextrow().
       o If you want to ignore all of the results from all of  the  com-
         mands in the current command batch, call dbcancel() instead.

  PARAMETERS:
       dbproc -  A pointer to the DBPROCESS structure that provides  the
           connection for a particular front-end/SQL Server process.  It



  3                       Version 4.0 -- 5/1/89               dbcanquery
  ______________________________________________________________________
           contains all the information that DB-Library uses  to  manage
           communications and data between the front end and SQL Server.

  RETURNS:
       SUCCEED or FAIL.  The most common reasons for failure are a  dead
       DBPROCESS or a network error.

  SEE ALSO:
       dbcancel, dbnextrow, dbresults, dbsetinterrupt, dbsqlexec










