
  1                       Version 4.0 -- 5/1/89                 DBCMDROW
  ______________________________________________________________________

  NAME:  DBCMDROW

  FUNCTION:
       Determine whether the current command can return rows.

  SYNTAX:
       RETCODE DBCMDROW(dbproc)

       DBPROCESS *dbproc;

  COMMENTS:

       o This macro  determines  whether  the  command  currently  being






  DBCMDROW                Version 4.0 -- 5/1/89                        2
  ______________________________________________________________________
         processed by dbresults() is one that can return rows,  i.e.,  a
         Transact-SQL  SELECT  statement  or an EXECUTE on a stored pro-
         cedure containing a SELECT.  The application can call it  after
         dbresults() returns SUCCEED.

       o Even if this macro returns SUCCEED, the command does not return
         any rows if none have qualified.  To determine whether any rows
         are actually being returned, use DBROWS().

  PARAMETERS:
       dbproc -  A pointer to the DBPROCESS structure that provides  the
           connection for a particular front-end/SQL Server process.  It
           contains all the information that DB-Library uses  to  manage
           communications and data between the front end and SQL Server.

  RETURNS:
       SUCCEED or FAIL, to indicate whether the command can return rows.



  3                       Version 4.0 -- 5/1/89                 DBCMDROW
  ______________________________________________________________________

  SEE ALSO:
       dbnextrow, dbresults, DBROWS, DBROWTYPE
















