
  1                       Version 4.0 -- 5/1/89              dbcolbrowse
  ______________________________________________________________________

  NAME:  dbcolbrowse

  FUNCTION:
       Determine whether the source of a regular result column is updat-
       able via the DB-Library browse-mode facilities.

  SYNTAX:
       DBBOOL dbcolbrowse(dbproc, colnum)

       DBPROCESS *dbproc;
       int       colnum;








  dbcolbrowse             Version 4.0 -- 5/1/89                        2
  ______________________________________________________________________

  COMMENTS:

       o dbcolbrowse() is one of the DB-Library  browse  mode  routines.
         See the Introduction for a detailed discussion of browse mode.
       o dbcolbrowse() provides a way to determine whether the  database
         column  that's  the  source  of  a  regular (i.e., non-compute)
         result column in a select-list is updatable via the  DB-Library
         browse-mode facilities.  This routine is useful in examining ad
         hoc queries.  If the query has been hardcoded into the program,
         dbcolbrowse() is obviously unnecessary.

       o To be updatable, a column must  be  derived  from  a  browsable
         table (i.e., the table must have a unique index and a timestamp
         column) and cannot be the result  of  a  SQL  expression.   For
         example, in the following select-list:

            select title, category=type, wholesale=(price * 0.6) ... for browse


  3                       Version 4.0 -- 5/1/89              dbcolbrowse
  ______________________________________________________________________

         result columns 1 and 2 ("title" and "category") are  updatable,
         but  column 3 ("wholesale") is not, because it is the result of
         an expression.

       o The  application  can  call  dbcolbrowse()   any   time   after
         dbresults().
       o To determine the name of the source column given  the  name  of
         the result column, use dbcolsource().

       o Example 7 in the DB-Library  Reference  Supplement  contains  a
         call to dbcolbrowse().

  PARAMETERS:
       dbproc -  A pointer to the DBPROCESS structure that provides  the
           connection for a particular front-end/SQL Server process.  It
           contains all the information that DB-Library uses  to  manage
           communications and data between the front end and SQL Server.


  dbcolbrowse             Version 4.0 -- 5/1/89                        4
  ______________________________________________________________________
       colnum -  The number of the result  column  of  interest.  Column
           numbers start at 1.

  RETURNS:
       TRUE or FALSE.

  SEE ALSO:
       dbcolsource, dbqual, dbtabbrowse, dbtabcount,  dbtabname,  dbtab-
       source, dbtsnewlen, dbtsnewval, dbtsput










