
  1                       Version 4.0 -- 5/1/89                   DBDEAD
  ______________________________________________________________________

  NAME:  DBDEAD

  FUNCTION:
       Determine whether a particular DBPROCESS is dead.

  SYNTAX:
       DBBOOL DBDEAD(dbproc)

       DBPROCESS *dbproc;

  COMMENTS:

       o This macro indicates whether or not the specified DBPROCESS  is






  DBDEAD                  Version 4.0 -- 5/1/89                        2
  ______________________________________________________________________
         dead.

         It is particularly useful in user-supplied error handlers.

       o If a DBPROCESS is dead, then almost  every  DB-Library  routine
         which receives it as a parameter will immediately fail, calling
         the user-supplied error handler.
       o Note:  If there is  no  user-supplied  error  handler,  a  dead
         DBPROCESS  will  cause  the affected DB-Library routines not to
         fail, but to abort the program.

  PARAMETERS:
       dbproc -  A pointer to the DBPROCESS structure that provides  the
           connection for a particular front-end/SQL Server process.  It
           contains all the information that DB-Library uses  to  manage
           communications and data between the front end and SQL Server.




  3                       Version 4.0 -- 5/1/89                   DBDEAD
  ______________________________________________________________________

  RETURNS:
       TRUE or FALSE.

  SEE ALSO:
       dberrhandle, errors













