
  1                       Version 4.0 -- 5/1/89               DBFIRSTROW
  ______________________________________________________________________

  NAME:  DBFIRSTROW

  FUNCTION:
       Return the number of the first row in the row buffer.

  SYNTAX:
       DBINT DBFIRSTROW(dbproc)

       DBPROCESS *dbproc;

  COMMENTS:

       o This macro returns the number of  the  first  row  in  the  row






  DBFIRSTROW              Version 4.0 -- 5/1/89                        2
  ______________________________________________________________________
         buffer.

       o If you aren't buffering  rows,  DBFIRSTROW(),  DBCURROW(),  and
         DBLASTROW()  always  have  the same value.  If you have enabled
         buffering by setting the DBBUFFER option, DBFIRSTROW()  returns
         the number of the first row in the row buffer.
       o Note that the first row returned from SQL Server  (whose  value
         is  1) is not necessarily the first row in the row buffer.  The
         rows in the row buffer are dependent  on  manipulation  by  the
         application  program.   See  the  dbclrbuf()  manual  page  for
         details.

  PARAMETERS:
       dbproc -  A pointer to the DBPROCESS structure that provides  the
           connection for a particular front-end/SQL Server process.  It
           contains all the information that DB-Library uses  to  manage
           communications and data between the front end and SQL Server.



  3                       Version 4.0 -- 5/1/89               DBFIRSTROW
  ______________________________________________________________________

  RETURNS:
       The number of the first row in the row buffer.  Rows are  counted
       from  the  first row returned from SQL Server, whose number is 1.
       This routine returns 0 if there's an error.

  SEE ALSO:
       dbclrbuf, DBCURROW,  dbgetrow,  DBLASTROW,  dbnextrow,  dbsetopt,
       options










