
  1                       Version 4.0 -- 5/1/89                dbgetchar
  ______________________________________________________________________

  NAME:  dbgetchar

  FUNCTION:
       Return a pointer to a character in the command buffer.

  SYNTAX:
       char *dbgetchar(dbproc, n)

       DBPROCESS *dbproc;
       int       n;

  COMMENTS:







  dbgetchar               Version 4.0 -- 5/1/89                        2
  ______________________________________________________________________

       o You can use dbgetchar() to find a particular character  in  the
         command  buffer.  It returns a pointer to the n'th character in
         the command buffer.
       o Internally, the command buffer is a linked  list  of  non-null-
         terminated   text   strings.    dbgetchar(),   dbstrcpy(),  and
         dbstrlen() together provide a way to locate and copy  parts  of
         the command buffer.

       o Since the command buffer is not just one large text string, but
         rather  a linked list of text strings, you must use dbgetchar()
         to index through the buffer.  If you just get a  pointer  using
         dbgetchar()  and  then  increment it yourself, it will probably
         fall off the end of a string and cause a segmentation fault.

  PARAMETERS:
       dbproc -  A pointer to the DBPROCESS structure that provides  the
           connection for a particular front-end/SQL Server process.  It


  3                       Version 4.0 -- 5/1/89                dbgetchar
  ______________________________________________________________________
           contains all the information that DB-Library uses  to  manage
           communications and data between the front end and SQL Server.
       n -  The character to find in  the  command  buffer.   The  first
           character is the 0'th character.

  RETURNS:
       dbgetchar() returns a pointer to the n'th character in  the  com-
       mand buffer.  If n is not in range, dbgetchar() returns NULL.

  SEE ALSO:
       dbcmd, dbfcmd, dbfreebuf, dbstrcpy, dbstrlen








