
  1                       Version 4.0 -- 5/1/89            dbgetuserdata
  ______________________________________________________________________

  NAME:  dbgetuserdata

  FUNCTION:
       Return a pointer to user-allocated data from a  DBPROCESS  struc-
       ture.

  SYNTAX:
       BYTE *dbgetuserdata(dbproc)

       DBPROCESS *dbproc;

  COMMENTS:







  dbgetuserdata           Version 4.0 -- 5/1/89                        2
  ______________________________________________________________________

       o This routine returns, from a DBPROCESS structure, a pointer  to
         user-allocated  data.   The  application  must  have previously
         saved this pointer with the dbsetuserdata() routine.
       o dbgetuserdata() and dbsetuserdata() allow  the  application  to
         associate  user  data with a particular DBPROCESS.  This avoids
         the necessity of using global variables for this purpose.   One
         use  for  these routines is to handle deadlock, as shown in the
         example on  the  dbsetuserdata()  manual  page.   That  example
         reruns  the  transaction when the application's message handler
         detects deadlock.

       o This routine is particularly useful when  the  application  has
         multiple DBPROCESSes.

  PARAMETERS:
       dbproc -  A pointer to the DBPROCESS structure that provides  the
           connection for a particular front-end/SQL Server process.  It


  3                       Version 4.0 -- 5/1/89            dbgetuserdata
  ______________________________________________________________________
           contains all the information that DB-Library uses  to  manage
           communications and data between the front end and SQL Server.

  RETURNS:
       A generic BYTE pointer to the user's private  data  space.   This
       pointer  must have been previously saved with the dbsetuserdata()
       routine.

  SEE ALSO:
       dbsetuserdata









