
  1                       Version 4.0 -- 5/1/89 DBIORDESC    (UNIX only)
  ______________________________________________________________________

  NAME:  DBIORDESC    (UNIX only)

  FUNCTION:
       Provide program access to the UNIX  file  descriptor  used  by  a
       DBPROCESS to read data coming from SQL Server.

  SYNTAX:
       int DBIORDESC(dbproc)

       DBPROCESS *dbproc;

  COMMENTS:







  DBIORDESC    (UNIX only)Version 4.0 -- 5/1/89                        2
  ______________________________________________________________________

       o This routine provides a  way  for  an  application  to  respond
         effectively to multiple input streams.  Depending on the nature
         of your application, the time between a request for information
         from  SQL Server  (usually  made via a call to dbsqlsend()) and
         SQL Server's response (read by calling dbsqlok(),  dbresults(),
         or  dbnextrow())  may  be significant. You may use this time to
         service other parts of your application. The  DBIORDESC()  rou-
         tine provides a way to obtain the I/O descriptor which a DBPRO-
         CESS uses to read the data stream from SQL Server.  This infor-
         mation  may  then be used with various operating system facili-
         ties (such as the UNIX select() call) to allow the  application
         to respond effectively to multiple input streams.
       o The file descriptor returned by this routine may only  be  used
         with operating system facilities that do not read data from the
         incoming data stream. If data is read from this stream  by  any
         means  other  than through a DB-Library routine, communications



  3                       Version 4.0 -- 5/1/89 DBIORDESC    (UNIX only)
  ______________________________________________________________________
         between the front-end and  SQL Server  will  become  hopelessly
         scrambled.

       o An application can use  the  DB-Library  DBRBUF()  routine,  in
         addition  to  the  UNIX  select()  function,  to help determine
         whether any more data from SQL Server is available for reading.
       o A companion routine, DBIOWDESC(), provides access to  the  file
         descriptor used to write data to SQL Server.

       o For an example that illustrates the  use  of  DBIORDESC()  with
         dbsqlsend() and dbsqlok(), see the DB-Library Reference Supple-
         ment.

  PARAMETERS:
       dbproc -  A pointer to the DBPROCESS structure that provides  the
           connection for a particular front-end/SQL Server process.  It
           contains all the information that DB-Library uses  to  manage
           communications and data between the front end and SQL Server.


  DBIORDESC    (UNIX only)Version 4.0 -- 5/1/89                        4
  ______________________________________________________________________

  RETURNS:
       An integer file descriptor used by  the  specified  DBPROCESS  to
       read data coming from SQL Server.

  SEE ALSO:
       dbcmd,  DBIOWDESC,   dbnextrow,   DBRBUF,   dbresults,   dbsqlok,
       dbsqlsend











