
  1                       Version 4.0 -- 5/1/89               dbmoretext
  ______________________________________________________________________

  NAME:  dbmoretext

  FUNCTION:
       Send part of a text or image value to SQL Server.

  SYNTAX:
       RETCODE dbmoretext(dbproc, size, text)

       DBPROCESS *dbproc;
       DBINT     size;
       BYTE      *text;








  dbmoretext              Version 4.0 -- 5/1/89                        2
  ______________________________________________________________________

  COMMENTS:

       o This routine is used in conjunction with dbwritetext() to  send
         a  large SYBTEXT or SYBIMAGE value to SQL Server in the form of
         a number of smaller chunks.  This is particularly  useful  with
         operating  systems  unable  to  allocate  extremely  long  data
         buffers.
       o dbmoretext() and dbwritetext() are used in  updates  only,  and
         serve to replace the Transact-SQL UPDATE statement.

       o dbsqlok() and dbresults() must be called before the first  call
         to dbmoretext() and after the last call to dbmoretext().
       o See the dbwritetext() manual page for more information, includ-
         ing an example that uses dbmoretext().

  PARAMETERS:



  3                       Version 4.0 -- 5/1/89               dbmoretext
  ______________________________________________________________________
       dbproc -  A pointer to the DBPROCESS structure that provides  the
           connection for a particular front-end/SQL Server process.  It
           contains all the information that DB-Library uses  to  manage
           communications and data between the front end and SQL Server.
       size -  The size, in bytes, of this particular part of  the  text
           or  image  value being sent to SQL Server.  It is an error to
           send more text or image bytes to SQL Server than were  speci-
           fied in the call to dbwritetext().
       text -  A pointer to the text or image portion to be written.

  RETURNS:
       SUCCEED or FAIL.

  SEE ALSO:
       dbtxptr, dbtxtimestamp, dbwritetext




