
  1                       Version 4.0 -- 5/1/89                 dbprtype
  ______________________________________________________________________

  NAME:  dbprtype

  FUNCTION:
       Convert a token value to a readable string.

  SYNTAX:
       char *dbprtype(token)

       int       token;

  COMMENTS:

       o Certain  routines-dbcoltype(),  dbalttype(),  dbrettype(),  and






  dbprtype                Version 4.0 -- 5/1/89                        2
  ______________________________________________________________________
         dbaltop()-return token values representing SQL Server datatypes
         or  aggregate operators.  dbprtype() provides a readable string
         version of a token value.

       o For example, dbprtype() will take  a  dbcoltype()  token  value
         representing  the  SQL Server  binary  datatype (SYBBINARY) and
         return the string "binary".
       o Here's a list of the token strings that dbprtype()  can  return
         and their token value equivalents:

            Token String    Token Value         Description

            char            SYBCHAR             char datatype
            text            SYBTEXT             text datatype
            binary          SYBBINARY           binary datatype
            image           SYBIMAGE            image datatype
            tinyint         SYBINT1             1-byte integer datatype
            smallint        SYBINT2             2-byte integer datatype


  3                       Version 4.0 -- 5/1/89                 dbprtype
  ______________________________________________________________________
            int             SYBINT4             4-byte integer datatype
            float           SYBFLT8             8-byte float datatype
            bit             SYBBIT              bit datatype
            money           SYBMONEY            money datatype
            datetime        SYBDATETIME         datetime datatype
            sum             SYBAOPSUM           sum aggregate operator
            avg             SYBAOPAVG           average aggregate operator
            count           SYBAOPCNT           count aggregate operator
            min             SYBAOPMIN           minimum aggregate operator
            max             SYBAOPMAX           maximum aggregate operator

  PARAMETERS:
       token -  The SQL Server  token  value  (SYBCHAR,  SYBFLT8,  etc.)
           returned  by  dbcoltype(), dbalttype(), dbrettype(), or dbal-
           top().

  RETURNS:



  dbprtype                Version 4.0 -- 5/1/89                        4
  ______________________________________________________________________
       A pointer to a null-terminated string that is the readable trans-
       lation  of  the token value.  The pointer points to space that is
       never overwritten, so it is safe to call this routine  more  than
       once  in  the same statement.  If the token value is unknown, the
       routine returns a pointer to an empty string.

  SEE ALSO:
       dbaltop, dbalttype, dbcoltype, dbrettype, types











