
  1                       Version 4.0 -- 5/1/89                   DBROWS
  ______________________________________________________________________

  NAME:  DBROWS

  FUNCTION:
       Indicate whether the current command actually returned rows.

  SYNTAX:
       RETCODE DBROWS(dbproc)

       DBPROCESS *dbproc;

  COMMENTS:

       o This macro  determines  whether  the  command  currently  being






  DBROWS                  Version 4.0 -- 5/1/89                        2
  ______________________________________________________________________
         processed by dbresults() returned any  rows.   The  application
         can call it after dbresults() returns SUCCEED.

       o The application must not call DBROWS() after dbnextrow().   The
         macro may return the wrong result at that time.
       o The application can use DBROWS() to determine whether it  needs
         to  call  dbnextrow()  to  process  result  rows.   If DBROWS()
         returns FAIL, the application can skip the dbnextrow() calls.

       o The DBCMDROW() macro determines whether the current command  is
         one that can return rows (i.e., a Transact-SQL SELECT statement
         or an EXECUTE on a stored procedure containing a SELECT).

  PARAMETERS:
       dbproc -  A pointer to the DBPROCESS structure that provides  the
           connection for a particular front-end/SQL Server process.  It
           contains all the information that DB-Library uses  to  manage
           communications and data between the front end and SQL Server.


  3                       Version 4.0 -- 5/1/89                   DBROWS
  ______________________________________________________________________

  RETURNS:
       SUCCEED or FAIL, indicating whether the current command  returned
       rows.

  SEE ALSO:
       DBCMDROW, dbnextrow, dbresults, DBROWTYPE












