
  1                       Version 4.0 -- 5/1/89                dbrpcsend
  ______________________________________________________________________

  NAME:  dbrpcsend

  FUNCTION:
       Signal the end of a remote procedure call.

  SYNTAX:
       RETCODE dbrpcsend(dbproc)

       DBPROCESS *dbproc;

  COMMENTS:

       o An application can call a stored  procedure  in  two  ways:  by






  dbrpcsend               Version 4.0 -- 5/1/89                        2
  ______________________________________________________________________
         executing a command buffer containing  a  Transact-SQL  EXECUTE
         statement  or  by  making a remote procedure call ("rpc").  See
         the manual page for dbrpcinit() for a discussion of the differ-
         ences between these techniques.

       o To make a remote procedure  call,  first  call  dbrpcinit()  to
         specify  the  stored procedure that's to be invoked.  Then call
         dbrpcparam() once for each of the  stored  procedure's  parame-
         ters.   Finally,  call  dbrpcsend()  to  signify the end of the
         parameter list.  This causes the server to begin executing  the
         specified procedure.  You can then call dbsqlok(), dbresults(),
         and dbnextrow() to  process  the  stored  procedure's  results.
         (Note  that you will need to call dbresults() multiple times if
         the stored procedure contains more than one SELECT  statement.)
         After all of the stored procedure's results have been processed
         you can call the routines that process  return  parameters  and
         status numbers, such as dbretdata() and dbretstatus().



  3                       Version 4.0 -- 5/1/89                dbrpcsend
  ______________________________________________________________________
       o For an example of a remote procedure call, see Example 8 in the
         DB-Library Reference Supplement.

  PARAMETERS:
       dbproc -  A pointer to the DBPROCESS structure that provides  the
           connection  for  a  particular  front-end/server process.  It
           contains all the information that DB-Library uses  to  manage
           communications and data between the front end and the server.

  RETURNS:
       SUCCEED or FAIL.

  SEE ALSO:
       dbnextrow,   dbresults,   dbretdata,   dbretstatus,    dbrpcinit,
       dbrpcparam, dbsqlok




