
  1                       Version 4.0 -- 5/1/89                DBSETLPWD
  ______________________________________________________________________

  NAME:  DBSETLPWD

  FUNCTION:
       Set the user SQL Server password in the LOGINREC structure.

  SYNTAX:
       RETCODE DBSETLPWD(loginrec, password)

       LOGINREC  *loginrec;
       char      *password;

  COMMENTS:







  DBSETLPWD               Version 4.0 -- 5/1/89                        2
  ______________________________________________________________________

       o This macro sets the user SQL Server password  in  the  LOGINREC
         structure.  For it to have any effect, it must be called before
         dbopen().

       o By default, the password field  of  the  LOGINREC  has  a  null
         value.   Therefore, you do not need to call this routine if the
         password is a null value.

       o DB-Library does not automatically blank  out  the  password  in
         loginrec  after  a call to dbopen().  Therefore, if you want to
         minimize the  risk  of  having  a  readable  password  in  your
         DB-Library  program,  you should set password to something else
         after you call dblogin().






  3                       Version 4.0 -- 5/1/89                DBSETLPWD
  ______________________________________________________________________

  PARAMETERS:
       loginrec -  A pointer to a  LOGINREC  structure,  which  will  be
           passed  as  an argument to dbopen().  You can get one by cal-
           ling dblogin().
       password -   The  SQL Server  password  that  will  be  sent   to
           SQL Server.   It  must be a null-terminated character string.
           The maximum length of the string, not including the null ter-
           minator, is 30 characters.

  RETURNS:
       SUCCEED or FAIL.

  SEE ALSO:
       dblogin, dbopen, DBSETLAPP, DBSETLHOST, DBSETLUSER




