
  1                       Version 4.0 -- 5/1/89                dbsettime
  ______________________________________________________________________

  NAME:  dbsettime

  FUNCTION:
       Set the number  of  seconds  that  DB-Library  will  wait  for  a
       SQL Server response to a SQL command.

  SYNTAX:
       RETCODE dbsettime(seconds)

       int       seconds;

  COMMENTS:







  dbsettime               Version 4.0 -- 5/1/89                        2
  ______________________________________________________________________

       o This routine sets the length of time in seconds that DB-Library
         will   wait   for   a   SQL Server  response  during  calls  to
         dbsqlexec(),  dbsqlok(),  dbresults(),  and  dbnextrow().   The
         default  timeout  value  is  0,  which  represents  an infinite
         timeout period.
       o dbsettime() can be called at any time during  the  application-
         before  or  after  a call to dbopen().  It takes effect immedi-
         ately upon being called.

       o To set a timeout value for calls to dbopen(),  use  dbsetlogin-
         time().
       o Note that, after sending a  query  to  SQL Server,  dbsqlexec()
         waits  until a response is received or until the timeout period
         has elapsed.  To minimize the time spent in DB-Library  waiting
         for a response from SQL Server, an application can instead call
         dbsqlsend() followed by dbsqlok().



  3                       Version 4.0 -- 5/1/89                dbsettime
  ______________________________________________________________________

       o The program can call DBGETTIME() to learn the  current  timeout
         value.
       o A timeout generates the DB-Library error "SYBETIME."

  PARAMETERS:
       seconds -   The  timeout  value-the  number   of   seconds   that
           DB-Library waits for a SQL Server response before timing out.
           A timeout value of 0 represents an infinite timeout period.

  RETURNS:
       SUCCEED or FAIL.

  SEE ALSO:
       dberrhandle,  DBGETTIME,  dbsetlogintime,   dbsqlexec,   dbsqlok,
       dbsqlsend



