
  1                       Version 4.0 -- 5/1/89                dbsqlsend
  ______________________________________________________________________

  NAME:  dbsqlsend

  FUNCTION:
       Send a command  batch  to  SQL Server  and  do  not  wait  for  a
       response.

  SYNTAX:
       RETCODE dbsqlsend(dbproc)

       DBPROCESS *dbproc;

  COMMENTS:







  dbsqlsend               Version 4.0 -- 5/1/89                        2
  ______________________________________________________________________

       o This routine sends SQL commands, stored in the command  buffer,
         to SQL Server.  The application can add commands to the command
         buffer by calling dbcmd() or dbfcmd().
       o Once dbsqlsend() returns SUCCEED,  the  application  must  call
         dbsqlok()  to  verify  the  accuracy of the command batch.  The
         application can then call dbresults() to process the results.

       o dbsqlexec() is equivalent to dbsqlsend() followed by dbsqlok().
       o The use of dbsqlsend() with dbsqlok() is of particular value in
         UNIX  applications.   After  sending  a  query  to  SQL Server,
         dbsqlexec() waits until a response is  received  or  until  the
         timeout  period  has  elapsed.  By substituting dbsqlsend() and
         dbsqlok() for dbsqlexec(), you can sometimes provide a way  for
         a  UNIX  application  to  respond  more effectively to multiple
         input and output streams.  The time  between  the  request  for
         information  from  SQL Server  (made via a call to dbsqlsend())



  3                       Version 4.0 -- 5/1/89                dbsqlsend
  ______________________________________________________________________
         and SQL Server's response (read by calling  dbsqlok())  can  be
         used,  in  conjunction with DBIORDESC() or DBIOWDESC(), to ser-
         vice  other  parts  of  the   application.    DBIORDESC()   and
         DBIOWDESC()  are available for UNIX only.  See the manual pages
         for those two routines for more information.

         For a UNIX example that illustrates the use of dbsqlsend() with
         dbsqlok(),  DBIORDESC()  and  DBIOWDESC(),  see  the DB-Library
         Reference Supplement.

  PARAMETERS:
       dbproc -  A pointer to the DBPROCESS structure that provides  the
           connection for a particular front-end/SQL Server process.  It
           contains all the information that DB-Library uses  to  manage
           communications and data between the front end and SQL Server.

  RETURNS:
       SUCCEED or FAIL.  dbsqlsend() may fail if  previous  results  had


  dbsqlsend               Version 4.0 -- 5/1/89                        4
  ______________________________________________________________________
       not been processed, or if the command buffer was empty.

  SEE ALSO:
       dbcmd, dbfcmd, DBIORDESC, DBIOWDESC, dbnextrow, dbresults, dbset-
       time, dbsqlexec, dbsqlok














