
  1                       Version 4.0 -- 5/1/89              dbtabbrowse
  ______________________________________________________________________

  NAME:  dbtabbrowse

  FUNCTION:
       Determine whether  the  specified  table  is  updatable  via  the
       DB-Library browse-mode facilities.

  SYNTAX:
       DBBOOL dbtabbrowse(dbproc, tabnum)

       DBPROCESS *dbproc;
       int       tabnum;








  dbtabbrowse             Version 4.0 -- 5/1/89                        2
  ______________________________________________________________________

  COMMENTS:

       o dbtabbrowse() is one of the DB-Library  browse  mode  routines.
         See the Introduction for a detailed discussion of browse mode.
       o dbtabbrowse() provides a way to identify browsable tables.   It
         is  useful  when  examining  ad hoc queries prior to performing
         browse mode updates based on them.  If the query has been hard-
         coded into the program, this routine is obviously unnecessary.

       o For a table to be considered "browsable," it must have a unique
         index and a timestamp column.
       o The  application  can  call  dbtabbrowse()   any   time   after
         dbresults().

       o Example 7 in the DB-Library  Reference  Supplement  contains  a
         call to dbtabbrowse().



  3                       Version 4.0 -- 5/1/89              dbtabbrowse
  ______________________________________________________________________

  PARAMETERS:
       dbproc -  A pointer to the DBPROCESS structure that provides  the
           connection for a particular front-end/SQL Server process.  It
           contains all the information that DB-Library uses  to  manage
           communications and data between the front end and SQL Server.
       tabnum -  The number of the table of interest,  as  specified  in
           the  SELECT  statement's FROM clause.  Table numbers start at
           1.

  RETURNS:
       TRUE or FALSE.

  SEE ALSO:
       dbcolbrowse, dbcolsource, dbqual, dbtabcount,  dbtabname,  dbtab-
       source, dbtsnewlen, dbtsnewval, dbtsput



