
  1                       Version 4.0 -- 5/1/89                dbtabname
  ______________________________________________________________________

  NAME:  dbtabname

  FUNCTION:
       Return the name of a table based on its number.

  SYNTAX:
       char *dbtabname(dbproc, tabnum)

       DBPROCESS *dbproc;
       int       tabnum;

  COMMENTS:







  dbtabname               Version 4.0 -- 5/1/89                        2
  ______________________________________________________________________

       o dbtabname() is one of the DB-Library browse mode routines.   It
         is  usable only with results from a browse-mode SELECT (i.e., a
         SELECT containing the key words FOR BROWSE).  See the Introduc-
         tion for a detailed discussion of browse mode.
       o A SELECT query can generate a set of result rows whose  columns
         are derived from several database tables.  dbtabname() provides
         a way for an application to determine the name  of  each  table
         involved  in  an ad hoc query.  If the query has been hardcoded
         into the program, this routine is obviously unnecessary.

       o The  application  can   call   dbtabname()   any   time   after
         dbresults().
       o Example 7 in the DB-Library  Reference  Supplement  contains  a
         call to dbtabname().

  PARAMETERS:



  3                       Version 4.0 -- 5/1/89                dbtabname
  ______________________________________________________________________
       dbproc -  A pointer to the DBPROCESS structure that provides  the
           connection for a particular front-end/SQL Server process.  It
           contains all the information that DB-Library uses  to  manage
           communications and data between the front end and SQL Server.
       tabnum -  The number of the table  of  interest.   Table  numbers
           start  with 1.  Use dbtabcount() to find out the total number
           of tables involved in a particular query.

  RETURNS:
       A pointer to the null-terminated name  of  the  specified  table.
       This  pointer will be NULL if the table number is out of range or
       if the specified table is  a  SQL Server  work  table.   See  the
       dbtabcount() manual page for a description of work tables.

  SEE ALSO:
       dbcolbrowse, dbcolsource, dbqual, dbtabbrowse, dbtabcount, dbtab-
       source, dbtsnewlen, dbtsnewval, dbtsput


