
  1                       Version 4.0 -- 5/1/89               dbtsnewlen
  ______________________________________________________________________

  NAME:  dbtsnewlen

  FUNCTION:
       Return the length of the new value of the timestamp column  after
       a browse-mode update.

  SYNTAX:
       int dbtsnewlen(dbproc)

       DBPROCESS *dbproc;

  COMMENTS:







  dbtsnewlen              Version 4.0 -- 5/1/89                        2
  ______________________________________________________________________

       o dbtsnewlen() is one of the  DB-Library  browse  mode  routines.
         See the Introduction for a detailed discussion of browse mode.
       o dbtsnewlen() provides information about the  timestamp  column.
         The  WHERE  clause  returned by dbqual() contains a call to the
         tsequal built-in function.  When such a WHERE clause is used in
         an UPDATE statement, the tsequal function places a new value in
         the updated row's timestamp column and returns the  new  times-
         tamp  value  to  the application (if the update is successful).
         The dbtsnewlen() function allows the application  to  save  the
         length  of  the  new  timestamp  value,  possibly  for use with
         dbtsput().

  PARAMETERS:
       dbproc -  A pointer to the DBPROCESS structure that provides  the
           connection for a particular front-end/SQL Server process.  It
           contains all the information that DB-Library uses  to  manage



  3                       Version 4.0 -- 5/1/89               dbtsnewlen
  ______________________________________________________________________
           communications and data between the front end and SQL Server.

  RETURNS:
       The length (in bytes) of the updated row's new  timestamp  value.
       If no timestamp was returned to the application (possibly because
       the update was unsuccessful, or because the UPDATE statement  did
       not  contain  the  tsequal  built-in function), dbtsnewlen() will
       return -1.

  SEE ALSO:
       dbcolbrowse, dbcolsource, dbqual, dbtabbrowse, dbtabcount, dbtab-
       name, dbtabsource, dbtsnewval, dbtsput







