
  1                       Version 4.0 -- 5/1/89                  dbtxptr
  ______________________________________________________________________

  NAME:  dbtxptr

  FUNCTION:
       Return the value of the text pointer for a column in the  current
       row.

  SYNTAX:
       DBBINARY *dbtxptr(dbproc, column)

       DBPROCESS *dbproc;
       int       column;








  dbtxptr                 Version 4.0 -- 5/1/89                        2
  ______________________________________________________________________

  COMMENTS:

       o Every database column row of type SYBTEXT or  SYBIMAGE  has  an
         associated  text pointer, which uniquely identifies the text or
         image value.  This text pointer is used  by  the  dbwritetext()
         function to update text and image values.
       o It's important that all the rows of the specified text or image
         column  have  valid  text pointers.  A text or image column row
         will have a valid text pointer if it contains  data.   However,
         if the text or image column row contains a null value, its text
         pointer will be valid only if the  null  value  was  explicitly
         entered with the UPDATE statement.

         Assume a table textnull with columns key and x, where  x  is  a
         text  column  that  permits  nulls.   The  following  statement
         assigns valid text pointers to the text column's rows:



  3                       Version 4.0 -- 5/1/89                  dbtxptr
  ______________________________________________________________________
            update textnull
            set x = null

         On the other hand, the INSERT of  a  null  value  into  a  text
         column does not provide a valid text pointer.  This is true for
         an INSERT of an explicit null or an INSERT of an implicit null,
         such as the following:

            insert textnull (key)
            values (2)

         When dealing with a null text or image value, be  sure  to  use
         UPDATE to get a valid text pointer.

       o For an example  that  uses  dbtxptr(),  see  the  dbwritetext()
         manual page.




  dbtxptr                 Version 4.0 -- 5/1/89                        4
  ______________________________________________________________________

  PARAMETERS:
       dbproc -  A pointer to the DBPROCESS structure that provides  the
           connection for a particular front-end/SQL Server process.  It
           contains all the information that DB-Library uses  to  manage
           communications and data between the front end and SQL Server.
       column -  The number of the column of interest.  The first column
           in a table is number 1.

  RETURNS:
       A DBBINARY  pointer  to  the  text  pointer  for  the  column  of
       interest.  This pointer may be NULL.

  SEE ALSO:
       dbtxtimestamp, dbwritetext




