
  1                       Version 4.0 -- 5/1/89            dbtxtimestamp
  ______________________________________________________________________

  NAME:  dbtxtimestamp

  FUNCTION:
       Return the value of the  text  timestamp  for  a  column  in  the
       current row.

  SYNTAX:
       DBBINARY *dbtxtimestamp(dbproc, column)

       DBPROCESS *dbproc;
       int       column;








  dbtxtimestamp           Version 4.0 -- 5/1/89                        2
  ______________________________________________________________________

  COMMENTS:

       o Every database column of type SYBTEXT or SYBIMAGE has an  asso-
         ciated  text  timestamp,  which  marks the time of the column's
         last modification.  The text timestamp is useful in conjunction
         with  the  dbwritetext() function, to ensure that two competing
         application users do not inadvertently wipe  out  each  other's
         modifications  to  the  same  value  in  the  database.   It is
         returned to the DBPROCESS when a Transact-SQL  SELECT  is  per-
         formed on a SYBTEXT or SYBIMAGE column.
       o The length of a non-NULL text  timestamp  is  always  DBTXTSLEN
         (currently defined as eight bytes).

       o For an example that uses dbtxtimestamp(), see the dbwritetext()
         manual page.




  3                       Version 4.0 -- 5/1/89            dbtxtimestamp
  ______________________________________________________________________

  PARAMETERS:
       dbproc -  A pointer to the DBPROCESS structure that provides  the
           connection for a particular front-end/SQL Server process.  It
           contains all the information that DB-Library uses  to  manage
           communications and data between the front end and SQL Server.
       column -  The number of the column of interest.  The first column
           in a table is number 1.

  RETURNS:
       A DBBINARY pointer to  the  text  timestamp  for  the  column  of
       interest.  This pointer may be NULL.

  SEE ALSO:
       dbtxptr, dbwritetext




