
  1                       Version 4.0 -- 5/1/89                dbtxtsput
  ______________________________________________________________________

  NAME:  dbtxtsput

  FUNCTION:
       Put the new value of a text timestamp into the  specified  column
       of the current row in the DBPROCESS.

  SYNTAX:
       RETCODE dbtxtsput(dbproc, newtxts, colnum)

       DBPROCESS *dbproc;
       DBBINARY  *newtxts;
       int       colnum;







  dbtxtsput               Version 4.0 -- 5/1/89                        2
  ______________________________________________________________________

  COMMENTS:

       o Every database column of type SYBTEXT or SYBIMAGE has an  asso-
         ciated  text  timestamp, which is updated whenever the column's
         value is changed.  The text timestamp is useful in  conjunction
         with  the  dbwritetext() function, to ensure that two competing
         application users do not inadvertently wipe  out  each  other's
         modifications  to  the  same  value  in  the  database.   It is
         returned to the DBPROCESS when a Transact-SQL  SELECT  is  per-
         formed  on  a SYBTEXT or SYBIMAGE column and may be examined by
         calling dbtxtimestamp().
       o After  each  successful  dbwritetext()  operation  (which   may
         include  a  number  of  calls to dbmoretext()), SQL Server will
         send the updated  text  timestamp  value  back  to  DB-Library.
         dbtxtsnewval() allows the application to get this new timestamp
         value.  The application can then use dbtxtsput() to put the new



  3                       Version 4.0 -- 5/1/89                dbtxtsput
  ______________________________________________________________________
         timestamp value into  the  DBPROCESS  row  buffer,  for  future
         access  via  dbtxtimestamp().  This is particularly useful when
         the application is buffering result rows and does not need  the
         new timestamp immediately.

  PARAMETERS:
       dbproc -  A pointer to the DBPROCESS structure that provides  the
           connection for a particular front-end/SQL Server process.  It
           contains all the information that DB-Library uses  to  manage
           communications and data between the front end and SQL Server.
       newtxts -  A pointer to the new  text  timestamp  value.   It  is
           returned by dbtxtsnewval().
       colnum -  The number of the  column  associated  with  this  text
           timestamp.  Column numbers start at 1.

  RETURNS:
       SUCCEED or FAIL.



  dbtxtsput               Version 4.0 -- 5/1/89                        4
  ______________________________________________________________________

  SEE ALSO:
       dbmoretext, dbtxtimestamp, dbtxtsnewval, dbwritetext
















