
  1                       Version 4.0 -- 5/1/89                dbvarylen
  ______________________________________________________________________

  NAME:  dbvarylen

  FUNCTION:
       Determine whether the specified regular result column's data  can
       vary in length.

  SYNTAX:
       DBBOOL dbvarylen(dbproc, column)

       DBPROCESS *dbproc;
       int       column;








  dbvarylen               Version 4.0 -- 5/1/89                        2
  ______________________________________________________________________

  COMMENTS:

       o This routine indicates  whether  a  particular  regular  (i.e.,
         non-compute)  result column's data can vary in length.  It will
         return TRUE if the result column is  derived  from  a  database
         column  of  type  varchar,  varbinary, text, or image.  It will
         also return TRUE if the source database column  is  defined  as
         NULL, meaning that it may contain a null value.
       o This routine  is  useful  with  programs  that  handle  ad  hoc
         queries,  if the program needs to be alerted to the possibility
         of null or variable length data.

       o You can use dbcoltype() to get a column's datatype.

  PARAMETERS:
       dbproc -  A pointer to the DBPROCESS structure that provides  the
           connection for a particular front-end/SQL Server process.  It


  3                       Version 4.0 -- 5/1/89                dbvarylen
  ______________________________________________________________________
           contains all the information that DB-Library uses  to  manage
           communications and data between the front end and SQL Server.
       column -  The number of the regular result  column  of  interest.
           The first column is number 1.

  RETURNS:
       TRUE or FALSE, indicating whether or not the  column's  data  can
       vary  in  length.   dbvarylen()  also returns FALSE if the column
       number is out of range.

  SEE ALSO:
       dbcollen,  dbcolname,  dbcoltype,  dbdata,  dbdatlen,  dbnumcols,
       dbprtype, types






