
  1                       Version 4.0 -- 1/15/89                defncopy
  ______________________________________________________________________

  NAME:  defncopy

  FUNCTION:
       Copies  definitions  for  specified   views,   rules,   defaults,
       triggers,  procedures,  or reports from a database to a host file
       or from a host file to a database.


       NOTE  _____________________________________________________________
       |                                                                 |
       |  The defncopy utility can not copy table definitions.           |
       |_________________________________________________________________|







  defncopy                Version 4.0 -- 1/15/89                       2
  ______________________________________________________________________

  SYNTAX:
       defncopy [ -U username ]  [ -P password ] [ -S server ] [-N ]
        [ -I interface ] { in filename dbname | out filename dbname
        [owner.]objectname [[owner.]objectname]...}

  PARAMETERS:
       -U username -  allows the user to specify a  login  name.   Login
           names are case sensitive.
       -P password -  allows the user to specify a password.  If -P  has
           no  argument,  defncopy uses the default password (NULL); put
           -P by itself at the end of the command line.  If  -P  is  not
           given, the user is prompted for a password.
       -S  server -   allows  the  user  to  specify  the  name  of  the
           SQL Server  with  which  to  connect.  Server names are case-
           sensitive, and are usually in upper case.
       -I interface -  allows the user to specify the name and  location



  3                       Version 4.0 -- 1/15/89                defncopy
  ______________________________________________________________________
           of the interfaces file that is (optionally) searched as  part
           of  the  process of connecting to SQL Server.  The named file
           contains the name and  network  address  of  every  available
           SQL Server  on  the  network.   If  this  option is not used,
           defncopy looks for a file named interfaces.
       in | out -  specifies the direction of definition copy.
       filename -  specifies the name of the operating system file  des-
           tination  or  source  for  the definition copy.  The copy out
           will overwrite an existing file.
       dbname -  specifies the name of the database from or to which the
           definitions are being copied.
       objectname -   specifies  name(s)  of  database   object(s)   for
           defncopy  to copy out.  This parameter is not used when copy-
           ing definitions in.

  COMMENTS:

       o The defncopy program is invoked  directly  from  the  operating


  defncopy                Version 4.0 -- 1/15/89                       4
  ______________________________________________________________________
         system.  defncopy provides a non-interactive way of copying out
         definitions  (CREATE  statements)  for  views, rules, defaults,
         triggers, procedures, or reports from  a  database  to  a  host
         file.   Alternatively, it will copy in all the definitions in a
         specified file.

       o The infile or outfile name and the database name  are  required
         and  must  be  unambiguously stated.  For copying out, use file
         names that reflect both the object's name and its owner.
       o Values specified to defncopy should be  enclosed  in  quotation
         marks  if  they contain characters that could be significant to
         the shell.

       o The defncopy utility cannot be used to copy table definitions.
       o You must have SELECT permission on objects in order to copy out
         their definitions.

       o You must have the appropriate CREATE permission for the type of


  5                       Version 4.0 -- 1/15/89                defncopy
  ______________________________________________________________________
         object you are copying in.  Objects copied  in  belong  to  the
         copier.   A  System  Administrator  copying  in  definitions on
         behalf of a user should be logged in as that user, in order for
         that  user  to have proper access to the reconstructed database
         objects.


  WARNING  _______________________________________________________________
  |                                                                      |
  |  Long comments (>100 characters) placed before a CREATE statement    |
  |  may cause defncopy to fail.                                         |
  |______________________________________________________________________|







