
  1                       Version 4.0 -- 5/1/89                   errors
  ______________________________________________________________________

  NAME:  errors

  FUNCTION:
       The complete collection of DB-Library errors  and  error  severi-
       ties.

  SYNTAX:
       #include <sybfront.h>
       #include <sybdb.h>
       #include <syberror.h>

  COMMENTS:







  errors                  Version 4.0 -- 5/1/89                        2
  ______________________________________________________________________

       o This is the complete range of possible  DB-Library  errors  and
         error  severities.  The error values are listed alphabetically,
         and the error severity values are listed by  increasing  sever-
         ity.
       o These numbers  are  passed  to  the  currently-installed  user-
         supplied error handler.

       o The error values are defined in the header file  sybdb.h.   The
         error   severity   values   are  defined  in  the  header  file
         syberror.h.  Your program need include syberror.h  only  if  it
         refers to these severities.

  ERRORS:
       SYBEAAMT          User attempted a dbaltbind() with mismatched column and variable types.
       SYBEABMT          User attempted a dbbind() with mismatched column and variable types.
       SYBEABNC          Attempt to bind to a non-existent column.
       SYBEABNP          Attempt to bind using NULL pointers.


  3                       Version 4.0 -- 5/1/89                   errors
  ______________________________________________________________________
       SYBEABNV          Attempt to bind to a NULL program variable.
       SYBEAPUT          Attempt to print unknown token.
       SYBEASEC          Attempt to send an empty command buffer to the SQL Server.
       SYBEASNL          Attempt to set fields in a null LOGINREC.
       SYBEASUL          Attempt to set unknown LOGINREC field.
       SYBEAUTN          Attempt to update the timestamp of a table which has no timestamp column.
       SYBEBBCI          Batch successfully bulk copied to SQL Server.
       SYBEBCBC          bcp_columns() must be called before bcp_colfmt().
       SYBEBCFO          Bcp host files must contain at least one column.
       SYBEBCIS          Attempt to bulk copy an illegally-sized column value to the SQL Server.
       SYBEBCNN          Attempt to bulk copy a NULL value into a Server column which
                         does not accept null values.
       SYBEBCNT          Attempt to use Bulk Copy with a non-existent Server table.
       SYBEBCOR          Attempt to bulk copy an oversized row to the SQL Server.
       SYBEBCPB          bcp_bind() may not be used after bcp_init() has been passed a
                         non-NULL input file name.




  errors                  Version 4.0 -- 5/1/89                        4
  ______________________________________________________________________
       SYBEBCPI          bcp_init() must be called before any other bcp routines.
       SYBEBCPN          bcp_bind(), bcp_collen() and bcp_colptr() may be used only after
                         bcp_init() has been called with the copy direction set to DB_IN.
       SYBEBCRE          I/O error while reading bcp datafile.
       SYBEBCUC          Bcp: Unable to close host datafile.
       SYBEBCUO          Bcp: Unable to open host datafile.
       SYBEBCVH          bcp_exec() may be called only after bcp_init() has been passed a
                         valid host file.
       SYBEBCWE          I/O error while writing bcp datafile.
       SYBEBDIO          Bad bulk copy direction.  Must be either IN or OUT.
       SYBEBEOF          Unexpected EOF encountered in BCP datafile.
       SYBEBIHC          Incorrect host-column number found in bcp format file.
       SYBEBIVI          bcp_columns() and bcp_colfmt() may be used only after bcp_init() has
                         been passed a valid input file.
       SYBEBNCR          Attempt to bind user variable to a non-existent compute row.
       SYBEBRFF          I/O error while reading bcp format file.
       SYBEBTMT          Attempt to send too much TEXT data via the bcp_moretext() call.



  5                       Version 4.0 -- 5/1/89                   errors
  ______________________________________________________________________
       SYBEBTOK          Bad token from SQL Server: Datastream processing out of sync.
       SYBEBTYP          Unknown bind type passed to DB-Library function.
       SYBEBUCE          Bcp: Unable to close error file.
       SYBEBUCF          Bcp: Unable to close format file.
       SYBEBUDF          Bcp: Unrecognized datatype found in format file.
       SYBEBUFL          DB-Library internal error - send buffer length corrupted.
       SYBEBUOE          Bcp: Unable to open error file.
       SYBEBUOF          Bcp: Unable to open format file.
       SYBEBWEF          I/O error while writing bcp error file.
       SYBEBWFF          I/O error while writing bcp format file.
       SYBECDNS          Datastream indicates that a compute column is derived from a non-
                         existent select-list member.
       SYBECLOS          Error in closing network connection.
       SYBECLPR          Data conversion resulted in loss of precision.
       SYBECNOR          Column number out of range.
       SYBECNOV          Attempt to set variable to NULL resulted in overflow.
       SYBECOFL          Data conversion resulted in overflow.



  errors                  Version 4.0 -- 5/1/89                        6
  ______________________________________________________________________

       SYBECONN          Unable to connect: SQL Server is unavailable or does not exist.
       SYBECSYN          Attempt to convert data stopped by syntax error in source field.
       SYBECUFL          Data conversion resulted in underflow.
       SYBEDBPS          Maximum number of DBPROCESSes already allocated.
       SYBEDDNE          DBPROCESS is dead or not enabled.
       SYBEDNTI          Attempt to use dbtxtsput() to put a new text timestamp into a column
                         whose datatype is neither SYBTEXT nor SYBIMAGE.
       SYBEFCON          SQL Server connection failed.
       SYBEICN           Invalid computeid or compute column number.
       SYBEIFNB          Illegal field number passed to bcp_control().
       SYBEIICL          Illegal integer column length returned by SQL Server. Legal integer
                         lengths are 1, 2, and 4 bytes.
       SYBEINLN          Interface file: unexpected end-of-line.
       SYBEINTF          Server name not found in interface file.
       SYBEITIM          Illegal timeout value specified.
       SYBEKBCI          1000 rows sent to SQL Server.



  7                       Version 4.0 -- 5/1/89                   errors
  ______________________________________________________________________
       SYBEKBCO          1000 rows successfully bulk copied to host file.
       SYBEMEM           Unable to allocate sufficient memory.
       SYBENMOB          No such member of ORDER BY clause.
       SYBENPRM          NULL parameter not allowed for this dboption.
       SYBENSIP          Negative starting index passed to dbstrcpy().
       SYBENTLL          Name too long for LOGINREC field.
       SYBENTTN          Attempt to use dbtxtsput() to put a new text timestamp into a
                         non-existent data row.
       SYBENXID          The Server did not grant us a distributed-transaction ID.
       SYBEOOB           Error in sending out-of-band data to SQL Server.
       SYBEOPIN          Could not open interface file.
       SYBEORPF          Attempt to set remote password would overflow the login-record's
                         remote password field.
       SYBEPWD           Login incorrect.
       SYBERDCN          Requested data conversion does not exist.
       SYBERDNR          Attempt to retrieve data from a non-existent row.
       SYBEREAD          Read from SQL Server failed.



  errors                  Version 4.0 -- 5/1/89                        8
  ______________________________________________________________________
       SYBERPND          Attempt to initiate a new SQL Server operation with results pending.
       SYBERXID          The Server did not recognize our distributed-transaction ID.
       SYBESEOF          Unexpected EOF from SQL Server.
       SYBESFOV          dbsafestr() overflowed its destination buffer.
       SYBESMSG          General SQL Server error: Check messages from SQL Server.
       SYBESOCK          Unable to open socket.
       SYBESYNC          Read attempted while out of synchronization with SQL Server.
       SYBETIME          SQL Server connection timed out.
       SYBETMTD          Attempt to send too much TEXT data via the dbmoretext() call.
       SYBETPTN          Syntax error: only two periods are permitted in table names.
       SYBETSIT          Attempt to call dbtsput() with an invalid timestamp.
       SYBETTS           The table which bulk copy is attempting to copy to a host file is shorter
                         than the number of rows which bulk copy was instructed to skip.
       SYBEUDTY          Unknown datatype encountered.
       SYBEUFDT          Unknown fixed-length datatype encountered.





  9                       Version 4.0 -- 5/1/89                   errors
  ______________________________________________________________________
       SYBEUHST          Unknown host machine name.
       SYBEUNT           Unknown network type found in interface file.
       SYBEUSCT          Unable to set communications timer.
       SYBEUVBF          Attempt to read an unknown version of BCP format file.
       SYBEUVDT          Unknown variable-length datatype encountered.
       SYBEVDPT          For bulk copy, all variable-length data must have either a
                         length-prefix or a terminator specified.
       SYBEWAID          DB-Library internal error: ALTFMT following ALTNAME has
                         wrong id.
       SYBEWRIT          Write to SQL Server failed.
       UNUSED            This error number is unused.




  ERROR SEVERITIES:




  errors                  Version 4.0 -- 5/1/89                       10
  ______________________________________________________________________
       EXINFO                Informational, non-error.
       EXUSER                User error.
       EXNONFATAL            Non-fatal error.
       EXCONVERSION          Error in DB-Library data conversion.
       EXSERVER              The Server has returned an error flag.
       EXTIME                We have exceeded our timeout period while waiting for a response
                             from the Server - the DBPROCESS is still alive.
       EXPROGRAM             Coding error in user program.
       EXRESOURCE            Running out of resources - the DBPROCESS may be dead.
       EXCOMM                Failure in communication with Server - the DBPROCESS is dead.
       EXFATAL               Fatal error - the DBPROCESS is dead.
       EXCONSISTENCY         Internal software error - notify Sybase Technical Support.

  SEE ALSO:
       DBDEAD, dberrhandle




