
  1                       Version 4.0 -- 5/1/89              open_commit
  ______________________________________________________________________

  NAME:  open_commit

  FUNCTION:
       Establish a connection with the commit service.

  SYNTAX:
       DBPROCESS *open_commit(login, servername)

       LOGINREC  *login;
       char      *servername;

  COMMENTS:







  open_commit             Version 4.0 -- 5/1/89                        2
  ______________________________________________________________________

       o This routine calls dbopen() to establish a connection with  the
         commit  service. A call to open_commit() must precede any calls
         to  other  commit  service  routines,  such  as   start_xact(),
         commit_xact(),  abort_xact(), remove_xact(), and scan_xact(). A
         session  with  the  commit  service  is   closed   by   calling
         close_commit().
       o This routine returns a DBPROCESS structure, which  is  used  to
         communicate  with  the  commit  service.  The DBPROCESS must be
         dedicated to its role with the commit service and should not be
         used otherwise in the distributed transaction.

  PARAMETERS:
       login -  This is a LOGINREC containing information about the user
           initiating the session, such as login name, password, options
           desired.  The LOGINREC must have been obtained from  a  prior
           call to the DB-Library routine dblogin(). The caller may wish



  3                       Version 4.0 -- 5/1/89              open_commit
  ______________________________________________________________________
           to initialize fields in the LOGINREC. See the manual page for
           dblogin() for more details.
       servername -  The  name  of  the  commit  service;  for  example,
           DSCOMMIT_SALESNET.   If servername is NULL, the name DSCOMMIT
           is used. The name cannot contain a period (".")  or  a  colon
           (":").

  RETURNS:
       A pointer to a DBPROCESS structure to be used in subsequent  com-
       mit service calls, or NULL if the open failed.

  SEE ALSO:
       dblogin, dbopen






