
  1                       Version 4.0 -- 5/1/89                    types
  ______________________________________________________________________

  NAME:  types

  FUNCTION:
       List of data typedefs and defines used by DB-Library.

  SYNTAX:
       #include <sybfront.h>
       #include <sybdb.h>

  COMMENTS:

       o Here is  a  list  of  SQL Server  datatypes.   dbconvert()  and
         dbwillconvert()  use  these  types.   In addition, the routines






  types                   Version 4.0 -- 5/1/89                        2
  ______________________________________________________________________
         dbcoltype(), dbalttype(), and dbrettype() will  return  one  of
         these types.

              SYBCHAR                 /* char type */
              SYBTEXT                 /* text type */
              SYBBINARY               /* binary type */
              SYBIMAGE                /* image type */
              SYBINT1                 /* 1-byte integer */
              SYBINT2                 /* 2-byte integer */
              SYBINT4                 /* 4-byte integer */
              SYBFLT8                 /* 8-byte float type */
              SYBBIT                  /* bit type */
              SYBMONEY                /* money type */
              SYBDATETIME             /* datetime type */

         For more information on SQL Server datatypes, see the  Commands
         Reference.



  3                       Version 4.0 -- 5/1/89                    types
  ______________________________________________________________________

       o Here is a list of typedefs used by DB-Library functions.  These
         typedefs  are  useful  for defining program variables, particu-
         larly variables used with  dbbind(),  dbaltbind(),  and  dbcon-
         vert().

              typedef char              DBCHAR;              /* char and text type */
              typedef unsigned char     DBBINARY;            /* binary and image type */
              typedef unsigned char     DBTINYINT;           /* 1-byte integer */
              typedef short             DBSMALLINT;          /* 2-byte integer */
              typedef unsigned short    DBUSMALLINT;         /* unsigned 2-byte integer */
              typedef long              DBINT;               /* 4-byte integer */
              typedef double            DBFLT8;              /* 8-byte float type */
              typedef unsigned char     DBBIT;               /* bit type */
              typedef int               RETCODE;             /* SUCCEED or FAIL */





  types                   Version 4.0 -- 5/1/89                        4
  ______________________________________________________________________
              typedef struct money                           /* money type */
              {
                  long                mnyhigh;
                  long                mnylow;
              } DBMONEY;

              typedef struct datetime                        /* datetime type */
              {
                  long                dtdays;                /* number of days since 1/1/1900 */
                  unsigned long       dttime;                /* 300ths of a second since midnight */
              } DBDATETIME;

              typedef struct dbvarychar                      /* Pascal-type string. */
              {
                  DBSMALLINT          len;                   /* character count */
                  DBCHAR              str[DBMAXCHAR];        /* non-terminated string */
              } DBVARYCHAR;



  5                       Version 4.0 -- 5/1/89                    types
  ______________________________________________________________________

              typedef struct dbvarybin                       /* Pascal-type binary array. */
              {
                  DBSMALLINT          len;                   /* byte count */
                  BYTE                array[DBMAXCHAR];      /* non-terminated array */
              } DBVARYBIN;

              typedef DBSMALLINT DBINDICATOR;                /* used by DB-Library
                                                                for indicator variables. */


  SEE ALSO:
       dbaltbind, dbalttype,  dbbind,  dbcoltype,  dbconvert,  dbprtype,
       dbrettype, dbwillconvert, options





